#include "RecvFileThread.h"
#include "MySyncObject.h"
#include "SendRecvThread.h"
#include "RingBuff.h"

CRecvFileThread::CRecvFileThread(CSendRecvThread *pCSendRecvThread)
{
	// p[^L
	m_pCSendRecvThread = pCSendRecvThread;

	// ϐ̏
	m_fIamZombie = FALSE;
	m_fdDstFile = -1;							// t@CfBXNv^
	m_iRecvFileStatus = RECVC_FILE_STAT_IDLE;	// t@CMR}h̑J
	memset(m_szFileName, 0, sizeof(m_szFileName)); // t@C폜̂߂̃t@C̏

	m_pCRingBuffCmd = new CRingBuff(CMD_BUFF_SIZE);	// t@CMR}hi[p
	m_pCMySyncObject = new CMySyncObject();
	m_pCMySyncObject->Initialize();
}


CRecvFileThread::~CRecvFileThread()
{
	if (m_pCMySyncObject != NULL)
		m_pCMySyncObject->Uninitialize();
	SAFE_DELETE(m_pCMySyncObject)
	SAFE_DELETE(m_pCRingBuffCmd)
// I[v܂܂̃t@C΂̂ŃN[YA폜
	if (m_fdDstFile != -1)
	{
		close(m_fdDstFile);
		unlink(m_szFileName);
	}
	m_fdDstFile = -1;
}

UINT CRecvFileThread::DoWork()
{
	BOOL		fRet = TRUE;

	while (!m_fStopFlag)
	{
		usleep(10 * 1000);			// usleepđ̃XbhɃ`X^
		if (AnalyzeCmd() == -1)		// Ԓl-1̎G[ÃXbh]rɂ
		{
			fRet = FALSE;
			break;
		}
	}
	m_pCMySyncObject->Lock();
	m_fIamZombie = TRUE;
	m_pCMySyncObject->UnLock();
	return((fRet == TRUE) ? 0 : -1);
}

//----------------------------------------------
// function
//		t@CMR}h̉
// parameter
//		Ȃ
// retun
//		0:\ȃf[^i[ĂȂȂ 1:͐ -1:͎s
//----------------------------------------------
int CRecvFileThread::AnalyzeCmd()
{
	int			iRet = 0;
	HeaderRec	Header;
	WORD		wCmd;
	int			iSize = m_pCRingBuffCmd->GetReadableSize();
	int			iPacketSize, iDataSize;
	LPBYTE		pbPacket = NULL;

	if (iSize < sizeof(HeaderRec))			// wb_TCYɖȂƂ͉Ȃ
		goto L_END;

	// wb_؂ǂݍ݂(pPbgۂƊi[Ă͂ł)
	m_pCRingBuffCmd->ReadWithoutUpdateHeadPoint((LPBYTE)&Header, sizeof(HeaderRec));
	wCmd = ntohs(Header.wCommand);
	iDataSize = ntohs(Header.wDataLen);
	iPacketSize = iDataSize + sizeof(HeaderRec);
	if (iSize < iPacketSize)				// pPbgTCYɖȂƂ͉Ȃ
		goto L_END;

	pbPacket = (LPBYTE)calloc(iPacketSize, sizeof(BYTE));
	// pPbgŜǂ
	m_pCRingBuffCmd->Read(pbPacket, iPacketSize);

	switch (wCmd)
	{
		case CMD_SEND_FILE_START_REQ:			// @MJnvM
			iRet = RecvSendFileStartPacket((SendFileStartReqRec *)pbPacket);
			break;
		case CMD_SEND_FILE_ING:					// At@CM
			iRet = RecvSendFileIngPacket((SendFileIngRec *)pbPacket);
			break;
		case CMD_SEND_FILE_END_REQ:				// BMvM
			iRet = RecvSendFileEndPacket((SendFileEndReqRec *)pbPacket);
			break;
		// CMD_SEND_FILE_ABORT_REQقǏ悤ɂ܂傤
		default:
			iRet = -1;							// mȂR}h
			break;
	}
L_END:
	SAFE_FREE(pbPacket)
	return(iRet);
}

//----------------------------------------------
// function
//		@t@CMJnR}h̎M
// parameter
//		 SendFileStartReqRec *pbPacket	[in]t@CMJnR}hpPbg
// retun
//		1:͐ -1:vIG[
//----------------------------------------------
int CRecvFileThread::RecvSendFileStartPacket(SendFileStartReqRec *pbPacket)
{
	int			iRet = 0;

	Locate(1, 11, 2);
	fprintf(stderr, "Start %s %s(%u)", pbPacket->FileInfo.szFileName, pbPacket->FileInfo.szFileSize, timeGetTime());

	if (m_iRecvFileStatus != RECVC_FILE_STAT_IDLE)
	{
		iRet = -1;						// JڏԃG[͐ؒf
		goto L_END;
	}
	// ŏݗpɃt@Copen
	if ((m_fdDstFile = open(pbPacket->FileInfo.szFileName,
		O_CREAT | O_WRONLY | O_TRUNC, S_IRUSR | S_IWUSR | S_IRGRP | S_IWGRP | S_IROTH | S_IWOTH)) == -1)
	{
		// t@CȂG[NCAgԂ悤ɂ܂
		goto L_END;
	}
	// Jnt@Co
	strcpy(m_szFileName, pbPacket->FileInfo.szFileName);
	m_iRecvFileStatus = RECVC_FILE_STAT_ING;
	// t@CMJnvԂ悤ɂ܂
	iRet = 1;
L_END:
	if (iRet == -1)					// G[I[vĂt@C΃N[YA폜
	{
		if (m_fdDstFile != -1)
		{
			close(m_fdDstFile);
			unlink(m_szFileName);
		}
		m_fdDstFile = -1;
	}
	return(iRet);
}

//----------------------------------------------
// function
//		t@CMR}h̎M
// parameter
//		 SendFileIngRec *pbPacket[in]t@CMR}hpPbg
// return
//		0:\ȃf[^i[ĂȂ 1:͐ -1:͎s
//----------------------------------------------
int CRecvFileThread::RecvSendFileIngPacket(SendFileIngRec *pbPacket)
{
	int			iRet = 0;
	long		lDataSize, lOffset;

	Locate(1, 12, 1);
	fprintf(stderr, "Ing %s %s", pbPacket->Stat.szOffset, pbPacket->Stat.szSize);

	if (m_iRecvFileStatus != RECVC_FILE_STAT_ING)
	{
		iRet = -1;				// JڏԃG[͐ؒf
		goto L_END;
	}
	lDataSize = atol(pbPacket->Stat.szSize);
	lOffset = atol(pbPacket->Stat.szOffset);
	if (lDataSize > 0)
	{
		// t@C쎸sG[ƂĐؒf
		if (lseek(m_fdDstFile, lOffset, SEEK_SET) == -1)
		{
			iRet = -1;
			goto L_END;
		}
		if (write(m_fdDstFile, pbPacket->bData, lDataSize) != lDataSize)
		{
			iRet = -1;
			goto L_END;
		}
	}
	iRet = 1;
L_END:
	if (iRet == -1)				// G[I[vĂt@C΃N[YA폜
	{
		if (m_fdDstFile != -1)
		{
			close(m_fdDstFile);
			unlink(m_szFileName);
		}
		m_fdDstFile = -1;
	}
	return(iRet);
}

//----------------------------------------------
// function
//		t@CMIR}h̎M
// parameter
//		 SendFileEndReqRec *pbPacket 	[in]t@CMIR}hpPbg
// return
//		0:\ȃf[^i[ĂȂ 1:͐ -1:͎s
//----------------------------------------------
int CRecvFileThread::RecvSendFileEndPacket(SendFileEndReqRec *pbPacket)
{
	int			iRet = 0;
	long		lDataSize, lOffset;

	Locate(1, 13, 1);
	fprintf(stderr, "End %s %s(%u)", pbPacket->Stat.szOffset, pbPacket->Stat.szSize, timeGetTime());

	if (m_iRecvFileStatus != RECVC_FILE_STAT_ING)
	{
		iRet = -1;				// JڏԃG[͐ؒf
		goto L_END;
	}
	lDataSize = atol(pbPacket->Stat.szSize);
	lOffset = atol(pbPacket->Stat.szOffset);
	if (lDataSize > 0)
	{
		// t@C쎸sG[ƂĐؒf
		if (lseek(m_fdDstFile, lOffset, SEEK_SET) == -1)
		{
			iRet = -1;
			goto L_END;
		}
		if (write(m_fdDstFile, pbPacket->bData, lDataSize) != lDataSize)
		{
			iRet = -1;
			goto L_END;
		}
	}
	iRet = 1;
	// MvԂ悤ɂ܂
L_END:
	if (m_fdDstFile != -1)
	{
		close(m_fdDstFile);
		if(iRet == -1)				// G[폜
			unlink(m_szFileName);
	}
	m_iRecvFileStatus = RECVC_FILE_STAT_IDLE;
	m_fdDstFile = -1;
	return(iRet);
}

//----------------------------------------------
// function
//    ̃Xbh̓]rԂ
//	  ʃXbhQƂ
// parameter
//    Ȃ
// return
//    0: -1:G[
//----------------------------------------------
BOOL CRecvFileThread::IsZombie()
{
	BOOL	fRet;

	m_pCMySyncObject->Lock();
	fRet = m_fIamZombie;
	m_pCMySyncObject->UnLock();
	return(fRet);
}
